@echo off
color 0a
title Make WAR file 1.0
pushd "%~dp0"

SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION

set QUICK_MODE=true
if /i "%QUICK_MODE%" equ "true" (
	set /a NS_CHOICE=0
) else (
	set /a NS_CHOICE=3
)

set CONFIG=%~1
if "%CONFIG%" equ "" (
	set CONFIG=%~n0.ini
)

call :FN_IS_FILE "%CONFIG%"
if "%RTN%" equ "false" (
	echo Invalid 'CONFIG'.
	goto :ERROR_EXIT
)

for /f "usebackq eol=# tokens=1* delims==" %%i in ("%CONFIG%") do (
	set %%i=%%~j
)
call :FN_FQPN JRE_BIN WP_LOCATION WF_DEST

call :FN_IS_DIR "%JRE_BIN%"
if "%RTN%" equ "false" (
	echo Invalid 'JRE_BIN'.
	goto :ERROR_EXIT
)
call :FN_IS_DIR "%WP_LOCATION%"
if "%RTN%" equ "false" (
	echo Invalid 'WP_LOCATION'.
	goto :ERROR_EXIT
)
call :FN_IS_DIR "%WF_DEST%"
if "%RTN%" equ "false" (
	echo Invalid 'WF_DEST'.
	goto :ERROR_EXIT
)

call :FN_TO_CANONICAL_PATH "%JRE_BIN%"
set JRE_BIN=%RTN%
set path=%path%;%JRE_BIN%

rem Work directory
set WORK_DIR=work

rem Logs directory
set LOG_DIR=logs

if exist "%WORK_DIR%\" (
	rmdir /s /q "%WORK_DIR%"
)
if exist "%WORK_DIR%" (
	del /f /q /a "%WORK_DIR%"
)
mkdir "%WORK_DIR%"

if not exist "%LOG_DIR%\" (
	if exist "%LOG_DIR%" (
		del /f /q /a "%LOG_DIR%"
	)
	mkdir "%LOG_DIR%"
)
set CUR_LOG=%LOG_DIR%\%date% %time::=_%.log
cd . > "%CUR_LOG%"

if "%WF_NAME%" equ "" (
	call :FN_SELF_NAME "%WP_LOCATION%"
	set WF_NAME=!RTN!
)

set RESOURCE_PATH=%WF_DEST%\%WF_NAME%.war

echo CONFIG -^> %CONFIG%
echo WORK_DIR -^> %WORK_DIR%
echo LOG_DIR -^> %LOG_DIR%
echo WP_LOCATION -^> %WP_LOCATION%
echo WF_NAME -^> %WF_NAME%
echo WF_DEST -^> %WF_DEST%
echo RESOURCE_PATH -^> %RESOURCE_PATH%

if /i "%OVERWRITE%" equ "false" (
	echo OVERWRITE -^> false
	if exist "%RESOURCE_PATH%" (
		echo Resource %RESOURCE_PATH% already exists. If you wish to overwrite select the "Overwrite Existing file" option.
		goto :ERROR_EXIT
	)
) else if /i "%OVERWRITE%" equ "true" (
	echo OVERWRITE -^> true
	if exist "%RESOURCE_PATH%" (
		del /f /q /a "%RESOURCE_PATH%"
	)
) else (
	echo Invalid value of 'OVERWRITE'.
	goto :ERROR_EXIT
)

pushd "%WORK_DIR%"
xcopy "%WP_LOCATION%\WebContent" . /e /q
xcopy "%WP_LOCATION%\build" WEB-INF /e /q
jar cfM "%RESOURCE_PATH%" -C . .
popd

>> "%CUR_LOG%" echo "%WP_LOCATION%" -^> "%RESOURCE_PATH%"
tree "%WORK_DIR%" /f /a >> "%CUR_LOG%"
rmdir /s /q "%WORK_DIR%"
echo Completed.
goto :NORMAL_EXIT

:NORMAL_EXIT
popd
choice /t %NS_CHOICE% /c O /cs /d O /n
exit

:ERROR_EXIT
pause
exit


@rem ##############################FBP Begin

rem to a fully qualified path name
rem eg. call :FN_FQPN XML_PATH INI_PATH
:FN_FQPN
if "%~1" equ "" goto :EOF
for /f "tokens=*" %%i in ("!%~1!") do (
	set %~1=%%~fi
)
shift
goto :FN_FQPN



rem eg. call :FN_IS_DIR "C:\MyDir\"
:FN_IS_DIR
call :FN_TO_CANONICAL_PATH "%~1"
if "%RTN%" equ "" (
	set RTN=false
	goto :EOF
)
if exist "%RTN%\" (
	set RTN=true
	goto :EOF
)
set RTN=false
goto :EOF



rem eg. call :FN_IS_FILE "C:\MyFile"
:FN_IS_FILE
call :FN_TO_CANONICAL_PATH "%~1"
if "%RTN%" equ "" (
	set RTN=false
	goto :EOF
)
if not exist "%RTN%\" (
	set RTN=true
	goto :EOF
)
set RTN=false
goto :EOF



rem eg. call :FN_TO_CANONICAL_PATH .
rem \\ -> network path
rem end with \, means it is a directory.
:FN_TO_CANONICAL_PATH
for /f "tokens=*" %%i in ("%~1") do (
	set RTN=%%~fi
	if exist "!RTN!\" (
		pushd "!RTN!\"
		set RTN=!CD!
		popd
	) else if not exist "!RTN!" (
		set RTN=
	)
)
goto :EOF



rem eg. call :FN_SELF_NAME .
:FN_SELF_NAME
call :FN_TO_CANONICAL_PATH "%~1"
if "%RTN%" equ "" (
	set RTN=
	goto :EOF
)
for /f "tokens=*" %%i in ("%RTN%") do (
	set RTN=%%~nxi
)
goto :EOF



rem eg. call :FN_PARENT_NAME .
:FN_PARENT_NAME
call :FN_SELF_NAME "%~1\.."
goto :EOF

@rem ##############################FBP End
